declare enum Action {
    PUSH = "push",
    BACK = "back",
    FORWARD = "forward",
    RESET = "reset"
}
export declare type HistoryState<T> = {
    past: T[];
    future: T[];
    present: T | null;
};
export declare type HistoryAction<T> = {
    type: Action.PUSH;
    state: T;
} | {
    type: Action.BACK;
} | {
    type: Action.FORWARD;
} | {
    type: Action.RESET;
    state?: T;
};
export declare type HistoryReduce = <T>(prevState: HistoryState<T>, action: HistoryAction<T>) => HistoryState<T>;
declare const createHistoryReducer: ({ maxSize, }: {
    maxSize?: number | undefined;
}) => HistoryReduce;
export { createHistoryReducer, Action };
